<?php
	
	require_once 'class.DB.php';
	
	class BugzillaModel {

		/****************** PRIVATE *******************/
		
		/**
		 * Updates single record in the db stores new one if not exists
		 */
		public static function _update($sKey, $aRecord) {
			DB::query('DELETE FROM `'.BUGZILLA_BUGS_TABLE.'` WHERE bug_id="'.$aRecord['id'].'"');
			$aDBRecord = array(
				'query_hash'		=> $sKey,
				'bug_id'			=> $aRecord['id'],
				'bug_creator'		=> $aRecord['creator'],
				'bug_assignee'		=> $aRecord['assigned_to'],
				'bug_verifier'		=> $aRecord['qa_contact'],
				'bug_is_open'		=> $aRecord['is_open'],
				'bug_is_confirmed'	=> $aRecord['is_confirmed'],
				'bug_data' 			=> serialize($aRecord)
			);
			DB::sanitize($aDBRecord);
			DB::insertArray(BUGZILLA_BUGS_TABLE, $aDBRecord);
			return true;
		}
		
		public static function _updateQueryTimestamp($sKey) {
			DB::query('DELETE FROM `'.BUGZILLA_QUERIES_TABLE.'` WHERE query_hash="'.$sKey.'"');
			DB::insertArray(BUGZILLA_QUERIES_TABLE, array(
				'query_hash' => $sKey
			));
		}
		
		public static function _getTimeElapsedForQuery($sKey) {
			return DB::selectFirstValue("SELECT NOW()-`updated` FROM ".BUGZILLA_QUERIES_TABLE." WHERE query_hash='$sKey'");
		}
		
		/****************** PUBLIC ********************/
		
		public static function isQueryDead($aQuery) {
			$sKey = md5(serialize($aQuery));
			$nElapsed = self::_getTimeElapsedForQuery($sKey);
			return $nElapsed ? ($nElapsed > BUGZILLA_QUERY_TTL) : true;
		}
		
		/**
		 * Updates records in the db, stores new one if not exists
		 */
		public static function update($aQuery, $aRecords) {
			$sKey = md5(serialize($aQuery));
			self::_updateQueryTimestamp($sKey);
			DB::query('DELETE FROM `'.BUGZILLA_BUGS_TABLE.'` WHERE query_hash="'.$sKey.'"');
			if (isset($aRecords['id'])) {
				return self::_update($sKey, $aRecords);
			}
			if (!isset($aRecords['bugs'])) { return; }
			foreach ($aRecords['bugs'] as $aRecord) {
				if (!self::_update($sKey, $aRecord)) {
					return false;
				}
			}
			return true;
		}
		
		public static function getBugs($aQuery) {
			$sKey = md5(serialize($aQuery));
			$aResults = DB::select("SELECT bug_data FROM ".BUGZILLA_BUGS_TABLE." WHERE query_hash='$sKey'");
			$aUnserializedResults = array();
			foreach ($aResults as $aResult) {
				$aUnserializedResults[] = unserialize($aResult['bug_data']);
			}
			return $aUnserializedResults;
		}
		
	}
	

?>